//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright ""
#property link      ""
#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 DarkGray
#property indicator_color2 Lime
#property indicator_color3 Lime
#property indicator_color4 OrangeRed
#property indicator_color5 OrangeRed
#property indicator_level1  -0.9
#property indicator_level2   0
#property indicator_level3   0.9
#property indicator_minimum -1.05
#property indicator_maximum  1.05
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2

//
//
//
//
//

extern string TimeFrame = "Current time frame";
extern int    StoPeriod = 89;
extern int    MA_Period = 9;
extern int    MA_Method = 3;

double Value[];
double iFish[];
double iFishua[];
double iFishub[];
double iFishda[];
double iFishdb[];
double state[];

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//


int init() 
{ 
   IndicatorBuffers(7);
   SetIndexBuffer(0, iFish); 
   SetIndexBuffer(1, iFishua); 
   SetIndexBuffer(2, iFishub); 
   SetIndexBuffer(3, iFishda); 
   SetIndexBuffer(4, iFishdb); 
   SetIndexBuffer(5, Value);
   SetIndexBuffer(6, state);
        indicatorFileName = WindowExpertName();
        calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
        returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
        timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" ift of stochastic ("+StoPeriod+","+MA_Period+")" );
   return(0); 
}  
int deinit() { return(0); } 

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start() 
{ 
   int counted_bars = IndicatorCounted(); 
      if (counted_bars < 0) return(-1); 
      if (counted_bars > 0) counted_bars--;  
         int limit=MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { iFish[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
      
   if (calculateValue || timeFrame==Period())
   {
      if (state[limit] ==  1) ClearPoint(limit,iFishua,iFishub);
      if (state[limit] == -1) ClearPoint(limit,iFishda,iFishdb);
      for (int i = limit; i >= 0; i--) 
      {      
         double up  = High[iHighest(NULL,0,MODE_HIGH,StoPeriod,i)];
         double dn  = Low[iLowest(NULL,0,MODE_LOW,StoPeriod,i)]; 
         double osc = 0;
            if (up!=dn) osc = MathMax(MathMin(100*(Close[i]-dn)/(up-dn),100),0);
                   Value[i] = 0.1*(osc-50.0);      
      }   
      for(i = limit; i >= 0; i--)    
      {
         double MA=iMAOnArray(Value,0,MA_Period,0,MA_Method,i);
            iFish[i]=(MathExp(2.0*MA)-1.0)/(MathExp(2.0*MA)+1.0);
            iFishua[i] = EMPTY_VALUE;
            iFishub[i] = EMPTY_VALUE;
            iFishda[i] = EMPTY_VALUE;
            iFishdb[i] = EMPTY_VALUE;
            state[i]   = 0;
               if (iFish[i]>  0.9) state[i] =  1;
               if (iFish[i]< -0.9) state[i] = -1;
               if (state[i] ==  1) PlotPoint(i,iFishua,iFishub,iFish);
               if (state[i] == -1) PlotPoint(i,iFishda,iFishdb,iFish);
      } 
      return(0); 
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (state[limit] ==  1) ClearPoint(limit,iFishua,iFishub);
   if (state[limit] == -1) ClearPoint(limit,iFishda,iFishdb);
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
        iFish[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StoPeriod,MA_Period,MA_Method,0,y);
        state[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StoPeriod,MA_Period,MA_Method,6,y);
        iFishua[i] = EMPTY_VALUE;
        iFishub[i] = EMPTY_VALUE;
        iFishda[i] = EMPTY_VALUE;
        iFishdb[i] = EMPTY_VALUE;
   }
   for (i=limit;i>=0;i--)
   {
      if (state[i] ==  1) PlotPoint(i,iFishua,iFishub,iFish);
      if (state[i] == -1) PlotPoint(i,iFishda,iFishdb,iFish);
   }
   return(0);
} 

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void ClearPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
   {
      if (first[i+2] == EMPTY_VALUE) 
      {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
      }
      else
      {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
      }
   }
   else
   {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
return(s);
}

